Whamcloud - gitweb
LU-5614 build: use %kernel_module_package in rpm spec
[fs/lustre-release.git] / contrib / lbuild / lbuild
1 #!/bin/bash
2
3 # vim:expandtab:shiftwidth=4:softtabstop=4:tabstop=4:
4
5 # this is an alternative FD for stdout, to be used especially when we are
6 # taking stdout from a function as it's return value.  i.e. foo=$(bar)
7 # this is a workaround until a version of bash where we can put xtrace
8 # on a specific FD
9 exec 3>&1; STDOUT=3
10
11 #set -x
12 xtrace="+x"
13 if [[ $SHELLOPTS = *xtrace* ]]; then
14     xtrace="-x"
15 fi
16 shopt -s extdebug
17
18 # Assume that lbuild's support files can be found in the same
19 # canonicalized path as this very script.
20 LBUILD_SCRIPT=$(readlink -f ${0})
21 LBUILD_DIR=${LBUILD_DIR:-$(dirname ${LBUILD_SCRIPT})}
22
23 # include the exit_traps library
24 . ${LBUILD_DIR}/exit_traps.sh
25 . ${LBUILD_DIR}/funcs.sh
26
27 # our children should die when we do
28 push_exit_trap "kill -INT -$$ || true" kill_children
29
30 # increment this if you have made a change that should force a new kernel
31 # to build built
32 #BUILD_GEN=1
33 #BUILD_GEN=2    # bz19952: remove -lustre tag from kernel RPM names
34 #BUILD_GEN=3    # bz19975: enable the building of src.rpms by default
35 #BUILD_GEN=4    # bz22281: use the git hash in the kernel extra version
36 #BUILD_GEN=5    # TT-107: don't cache the BUILD dir
37 BUILD_GEN=6     # TT-1092: don't cache the BUILD dir, to rebuild external OFED
38
39 TOPDIR="$PWD"
40
41 KERNELDIR=
42 LINUX=
43 LUSTRE=
44 RELEASE=false
45 # XXX - some recent hacking has pretty much neutered this option.
46 #       search through this file for "-bb" and see how many places
47 #       simply don't account for this option
48 DO_SRC=true
49 DOWNLOAD=true
50 CANONICAL_TARGET=
51 TARGET=
52 TARGET_ARCH="$(uname -m)"
53 # change default behavior to only build for the current arch
54 TARGET_ARCHS="$TARGET_ARCH"
55 TARGET_ARCHS_ALL="$TARGET_ARCH"
56 [ "$TARGET_ARCH" = "i686" ] && TARGET_ARCHS_ALL="i686 i586 i386"
57 CONFIGURE_FLAGS=
58 EXTERNAL_PATCHES=
59 EXTRA_VERSION=
60 STAGEDIR=
61 TMPDIR=${TMPDIR:-"/var/tmp"}
62 TIMESTAMP=
63 # this is the dir that should be used to store reuse products
64 REUSEBUILD=
65 # should cached products be used or force rebuilding?
66 USE_BUILD_CACHE=true
67 # what does this do exactly?  does it imply no kernel build?
68 IOKITRPM=true
69 OSDLDISKFSRPM=true
70 OSDZFSRPM=false
71 SMPTYPES="smp bigsmp default ''"
72 PATCHLESS=false
73 WITH_ZFS=""
74 XEN=false
75 LINUXOBJ=
76 DISTRO=
77 KERNELTREE=
78 # default to not adding -lustre- into the kernel RPM package names
79 KERNEL_LUSTRE_NAMING=false
80 # default not use kabi check.
81 USE_KABI=false
82
83 # patchless build
84 KERNELRPMSBASE=
85 RPMSMPTYPE=
86
87 # from target file
88 SERIES=
89 BASE_ARCHS=
90 BIGMEM_ARCHS=
91 BOOT_ARCHS=
92 JENSEN_ARCHS=
93 SMP_ARCHS=
94 BIGSMP_ARCHS=
95 PSERIES64_ARCHS=
96 UP_ARCHS=
97
98 # not in the target file any more
99 CONFIG=
100
101 # build the lustre-tests rpm?
102 LUSTRE_TESTS=true
103
104 DATE=$(date)
105
106 export CC=${CC:-gcc}
107
108 # Readlink is not present on some older distributions: emulate it.
109 readlink() {
110     local path=$1 ll
111
112     if [ -L "$path" ]; then
113         ll="$(LC_ALL=C ls -l "$path" 2> /dev/null)" &&
114         echo "${ll/* -> }"
115     else
116         return 1
117     fi
118 }
119
120 usage() {
121     cat <<EOF
122 Usage: ${0##*/} [OPTION]... [-- <lustre configure options>]
123
124   --external-patches=EXTERNAL_PATCHES
125     Directory similar to lustre/lustre/kernel_patches/ that lbuild should
126     look for seres and config files in before looking in the lustre
127     tree.
128
129   --extraversion=EXTRAVERSION
130     Text to use for the rpm release and kernel extraversion.
131
132   --timestamp=TIMESTAMP
133     Date of building lustre in format YYYYMMDDhhmmss
134
135   --reusebuild=DIR
136     Try to reuse old kernel builds from DIR
137
138   --kernelrpm=DIR
139     Path to distro kernel RPM collection
140
141   --ccache
142     Use ccache
143
144   --norpm
145     Unused.
146
147   --patchless
148     Build lustre client only
149
150   --distro=DISTRO
151     Which distro using. Autodetect by default
152
153   --kerneldir=KERNELDIR
154     Directory containing Linux source tarballs referenced by target
155     files.
156
157   --kerneltree=KERNELTREE
158     Directory containing dirs with Linux source tarballs referenced by target
159     files. Dir names in format kernel version ('2.6.9', etc.)
160
161   --linux=LINUX --with-linux=LINUX
162     Directory of Linux kernel sources.  When this option is used, only
163     Lustre modules and userspace are built.
164
165   --lustre=LUSTRE
166     Path to an existing lustre source tarball to use.
167
168   --nodownload
169     Do not try to download a kernel from downloads.hpdd.intel.com
170
171   --nosrc
172     Do not build a .src.rpm, a full kernel patch, or a patched kernel
173     tarball.
174
175   --ldiskfs
176     Build with ldiskfs support. (Deprecated, always true)
177
178   --noiokit
179     Do not build lustre-iokit RPM. Now true by default
180
181   --publish
182     Unused.
183
184   --release
185     Specifies that the files generated do not include timestamps, and
186     that this is an official release.
187
188   --disable-zfs
189     Build Lustre without ZFS.
190
191   --src
192     Build a .src.rpm, a full kernel patch, and a patched kernel tarball.
193
194   --stage=DIR
195     Directory used to stage packages for release.  RPMs will be placed
196     more or less in DIR/<target>-<arch>, and the tarball will be
197     placed in DIR.
198
199   --target=TARGET
200     The name of the target to build.  The available targets are listed
201     below.
202
203   --target-archs=TARGET_ARCHS
204     A (space delimited) list of architectures to build.  By default,
205     all of the archs supported by the TARGET will be built, in
206     addition to a .src.rpm.  This option can limit those, for machines
207     that can only build certain archs or if you only want a certain
208     arch built (for testing, or a one-off kernel).
209
210     Also note that by using a non-"base" arch (eg, i386) only kernels
211     will be built - there will be no lustre-lite-utils package.
212
213   --xen
214     Builds a Xen domX kernel.
215
216   --set-value
217     Sets a variable to a given value.
218
219 EOF
220
221 #   list_targets
222
223     fatal "$1" "$2"
224 }
225
226 # canonicalize a relative path to a file
227 canon_filepath() {
228     local PATH="$1"
229
230     if [ ! -f "$PATH" ]; then
231         return 1
232     fi
233
234     local FILE=${PATH##*/}
235     local DIR=${PATH%/*}
236
237     echo $(canon_path "$DIR")/$FILE
238     return 0
239 }
240
241 # canonicalize a relative path to a dir
242 canon_path() {
243     local PATH="$1"
244
245     if [ ! -d "$PATH" ]; then
246         return 1
247     fi
248
249     pushd "$PATH" >/dev/null || return 1
250     local CANONPATH=$PWD
251     popd >/dev/null
252
253     echo "$CANONPATH"
254     return 0
255 }
256
257 check_options() {
258
259     if [ -z "$LUSTRE" -o ! -r "$LUSTRE" ]; then
260         usage 1 "Could not find Lustre source tarball '$LUSTRE'."
261     fi
262
263     if [ -z "$DISTRO" ] ; then
264         DISTRO=$(autodetect_distro)
265         # remove separator
266         DISTRO=${DISTRO/-/}
267     fi
268     DISTROMAJ=${DISTRO%%.*}
269
270     [ -z "$TARGET" ] && TARGET=$(autodetect_target "$DISTRO")
271
272     if [ -z "$LINUX" ]; then
273         [ "$KERNELDIR" -o "$KERNELTREE" ] || \
274             usage 1 "A kernel directory must be specified with --kerneldir or --kerneltree."
275
276         [ -d "$KERNELDIR" -o -d "$KERNELTREE" ] || \
277             usage 1 "$KERNELDIR and $KERNELTREE are not a directory."
278
279 #       TARGET_FILE="$TOPDIR/lustre/kernel_patches/targets/$TARGET.target"
280 #       [ -r "$TARGET_FILE" ] || \
281 #               usage 1 "Target '$TARGET' was not found."
282     fi
283
284     case $TARGET in
285         3.12-sles12)
286             CANONICAL_TARGET="sles12"
287             ;;
288         3.10-rhel7)
289             CANONICAL_TARGET="rhel7"
290             ;;
291         2.6-rhel6*)
292             CANONICAL_TARGET="rhel6"
293             ;;
294         2.6-rhel5)
295             CANONICAL_TARGET="rhel5"
296             ;;
297         2.6-rhel4)
298             CANONICAL_TARGET="rhel-2.6"
299             ;;
300         2.6-suse)
301             CANONICAL_TARGET="sles-2.6"
302             ;;
303         2.6-sles10)
304             CANONICAL_TARGET="sles10-2.6"
305             ;;
306         2.6-sles11 | 3.0-sles11)
307             CANONICAL_TARGET="sles11"
308             ;;
309         2.6-oel5)
310             CANONICAL_TARGET="oel5"
311             ;;
312         hp_pnnl-2.4)
313             CANONICAL_TARGET="hp-pnnl-2.4"
314             ;;
315         2.6-vanilla \
316             | suse-2.4.21-2 \
317             | rh-2.4 \
318             | rhel-2.4 \
319             | sles-2.4 \
320             | 2.6-patchless)
321                 CANONICAL_TARGET="$TARGET"
322                 ;;
323     esac
324
325     local timestampnodig=$(echo $TIMESTAMP | sed -e s/[0-9]*//g)
326     [ "$timestampnodig" = "" ] || TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
327     local timestamplength="${#TIMESTAMP}"
328     if [ $timestamplength -eq 12 ]; then
329         TIMESTAMP="${TIMESTAMP}00"
330     elif [ $timestamplength -ne 14 ]; then
331         TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
332     fi
333
334     local RPMBUILD=$(which rpmbuild 2>/dev/null | head -n 1)
335     RPMBUILD=${RPMBUILD:-$(which rpm 2>/dev/null | head -n 1)}
336     if [ -z "$RPMBUILD" ]; then
337         usage 1 "Could not find binary for making rpms (tried rpmbuild and rpm)."
338     fi
339
340     local BINDIR="$TOPDIR/bin"
341     if [ -d $BINDIR ]; then
342         rm -rf $BINDIR >/dev/null 2>&1 || true
343     fi
344
345     mkdir -p $BINDIR || fatal 1 "error trying to create $BINDIR"
346     export PATH=$BINDIR:$PATH
347
348     cat >${BINDIR}/rpmbuild <<EOF
349 #!/bin/bash
350
351 ARGS="\${FIND_REQUIRES:+--define \"__find_requires \$FIND_REQUIRES\"}"
352 for arg; do
353     case \$arg in
354     *\'* ) ARGS="\$ARGS \"\$arg\"" ;;
355     * ) ARGS="\$ARGS '\$arg'" ;;
356     esac
357 done
358
359 eval $RPMBUILD \$ARGS
360 EOF
361     chmod 755 ${BINDIR}/rpmbuild
362
363     if [ -n "$CCACHE" ]; then
364         which "$DISTCC" &>/dev/null && export DISTCC RPM_BUILD_NCPUS
365
366         if which "$CCACHE" &>/dev/null; then
367             local ccache=$(which "$CCACHE" 2>/dev/null | head -n 1)
368
369             ln -s "$ccache" ${BINDIR}/ccache
370             ln -s "$ccache" ${BINDIR}/cc
371             ln -s "$ccache" ${BINDIR}/$CC
372
373             export CCACHE
374             export CC="ccache $CC"
375             # zero the cache so we can see how effective we are being with it
376             echo -n "ccache "
377             ccache -z
378
379             # get some ccache stats when we are done
380             push_exit_trap '[ -n "$CCACHE" ] && ccache -s' "ccache_summary"
381             # should remove the ccache trap if lbuild is interrupted
382             trap 'echo "Received an INT TERM or HUP signal, terminating."; delete_exit_trap "ccache_summary"; exit 1' INT TERM HUP
383         fi
384     fi
385
386     return 0
387 }
388
389 # compare two versions $1 and $2. if $1 < $2, return 0 otherwise return 1.
390 compare_version () {
391     [[ $1 == $2 ]] && return 1
392     local IFS=.
393     local i val1=($1) val2=($2)
394
395     # padding zero to val1 if it needs
396     for ((i=${#val1[@]}; i<${#val2[@]}; i++)); do
397         val1[i]=0
398     done
399     for ((i=0; i<${#val1[@]}; i++)); do
400         [[ -z ${val2[i]} ]] && return 1
401
402         if [[ ${val1[i]} < ${val2[i]} ]]; then
403             return 0
404         elif [[ ${val1[i]} > ${val2[i]} ]]; then
405             return 1
406         fi
407     done
408
409     return 0
410 }
411
412 uniqify() {
413
414     echo $(echo "$*" | xargs -n 1 | sort -u)
415
416 }
417
418 fetch_url() {
419     local url="$1"
420     local target="$2"
421
422     if [ -z "$target" ]; then
423         fatal 1 "fetch_url() called without a target to fetch to"
424     fi
425
426     if [ -d $target ]; then
427         target+="/${url##*/}"
428     fi
429
430     local rc=0
431     if which wget >/dev/null 2>&1; then
432         if ! wget -nv "$url" -O "$target"; then
433             rc=${PIPESTATUS[0]}
434         fi
435     elif which curl >/dev/null 2>&1; then
436         if ! curl -n -L -s -o "$target" "$url"; then
437             rc=${PIPESTATUS[0]}
438         fi
439     else
440         fatal 1 "Could not find either wget or curl to fetch URLs."
441     fi
442
443     return $rc
444
445 }
446
447 download_srpm() {
448     local target=$1
449     local srpm=$2
450     local force="${3:-false}"
451
452     if $force || [ ! -r "$KERNELDIR/$srpm" ] ||
453        [ ! -s "$KERNELDIR/$srpm" ]; then
454         if $DOWNLOAD; then
455             local location="https://downloads.hpdd.intel.com/public/kernels/$target/old"
456             # get the location from a distro specific method if it exists
457             if type -p kernel_srpm_location; then
458                 location=$(kernel_srpm_location)
459             fi
460             echo "Downloading $location/$srpm..."
461             if ! fetch_url "$location/$srpm" "$KERNELDIR/$srpm" 2>&1 ||
462                [ ! -s "$KERNELDIR/$srpm" ]; then
463                 rm -f $KERNELDIR/$srpm
464                 # punt to a distro specific method if it exists
465                 if ! type -p download_srpm-$DISTROMAJ; then
466                     fatal 1 "Could not download target $target's kernel SRPM $srpm from $location."
467                 else
468                     if ! download_srpm-$DISTROMAJ "$target" "$srpm" "$force"; then
469                         fatal 1 "Could not download target $target's kernel SRPM $srpm using download_srpm-$DISTROMAJ."
470                     fi
471                 fi
472             fi
473         else
474             fatal 1 "$srpm not found in directory $KERNELDIR."
475         fi
476     fi
477
478 }
479
480 download_file() {
481     local from="$1"
482     local to="$2"
483     local force="$3"
484
485     local file=${from##*/}
486
487     if [ -d $to ]; then
488         to="$to/$file"
489     fi
490
491     local semaphore="$to-downloading"
492
493     is_downloading() {
494         if [ ! -f $semaphore ]; then
495             return 1
496         fi
497
498         # make sure the download has not been aborted
499         local now=$(date +%s)
500         local file_mtime=$(stat -c %Y "$to")
501         local staleness=$((now - file_mtime))
502         # let's assume an active download will write at least once a minute
503         if [ $staleness -gt 60 ]; then
504             return 1
505         fi
506
507         return 0
508     }
509
510     is_downloaded() {
511         # if the semaphore file exists, the file is either still downloading
512         # or a download was aborted and we cannot trust the target file
513         if [ -f $semaphore ]; then
514             return 1
515         fi
516
517         if ! is_downloading && [ -r "$to" ] && [ -s "$to" ]; then
518             return 0
519         fi
520
521         return 1
522     }
523
524     if $force || ! is_downloaded; then
525         if is_downloading; then
526             echo "Somebody else is downloading $from..."
527             while is_downloading; do
528                 echo "Waiting for $to to finish downloading"
529                 sleep 60
530             done
531             if is_downloaded; then
532                 return 0
533             else
534                 echo "The download we were waiting for seems to have been aborted"
535             fi
536
537         fi
538
539         if $DOWNLOAD; then
540             echo "Downloading $from..."
541             # flag others so they don't try to download also
542             push_exit_trap "rm -f $to $semaphore" "download"
543             touch $semaphore
544             if ! fetch_url "$from" "$to" || [ ! -s "$to" ]; then
545                 # the trap will remove the files via the fatal below
546                 fatal 1 "Could not download ${to##*/} from ${from%/*}/."
547             fi
548             rm -f $semaphore
549             delete_exit_trap "download"
550         else
551             fatal 1 "${to##*/} not found in directory ${to%/*}."
552         fi
553     fi
554
555     return 0
556
557 }
558
559 download_ofed() {
560     local force="${1:-false}"
561
562     if [ -z "$OFED_VERSION" -o "$OFED_VERSION" = "inkernel" ]; then
563         return 0
564     fi
565
566     local OFED_BASE_VERSION=$OFED_VERSION
567     if [[ $OFED_VERSION = *.*.*.* ]]; then
568         OFED_BASE_VERSION=${OFED_VERSION%.*}
569     fi
570
571     local location="https://www.openfabrics.org/downloads/OFED/ofed-${OFED_BASE_VERSION}/"
572
573     if [[ $OFED_VERSION = *-[rR][cC][0-9] ]]; then
574         local Mmv
575         Mmv=${OFED_VERSION%%-[rR][cC][0-9]}
576         location="https://www.openfabrics.org/downloads/OFED/ofed-${Mmv}/"
577     fi
578
579     if [[ $OFED_VERSION = daily-* ]]; then
580         local Mmv
581         Mmv=${OFED_VERSION/daily-/}
582         daily=${OFED_VERSION##$Mmv-}
583         location="https://www.openfabrics.org/downloads/OFED/ofed-${Mmv}-daily/"
584         # find the filename for the version for the date specified
585         OFED_VERSION=$(curl -s "$location" | sed -nre "/${Mmv}-/s/.*href=\"OFED-(${Mmv}-[0-9]{8,8}-[0-9]{4,4}).tgz.*$/\1/p" | tail -1)
586         if [ -z "$OFED_VERSION" ]; then
587             fatal 1 "Could not determine the filename of the OFED snapshot for ${daily}"
588         fi
589     fi
590
591     local file="OFED-${OFED_VERSION}.tgz"
592     download_file "$location/$file" "$KERNELTREE" "$force"
593
594 }
595
596 load_target() {
597
598     EXTRA_VERSION_save="$EXTRA_VERSION"
599     for patchesdir in "$EXTERNAL_PATCHES" \
600                       "$TOPDIR/lustre/lustre/kernel_patches"; do
601         TARGET_FILE="$patchesdir/targets/$TARGET.target"
602         [ -r "$TARGET_FILE" ] && break
603     done
604     [ -r "$TARGET_FILE" ] || fatal 1 "Target $TARGET was not found."
605
606     echo "Loading target config file $TARGET.target..."
607
608     # if the caller specified an OFED_VERSION it should override whatever
609     # the target file specifies
610     local env_OFED_VERSION="$OFED_VERSION"
611
612     . "$TARGET_FILE"
613
614     if [ -n "$env_OFED_VERSION" ]; then
615         OFED_VERSION="$env_OFED_VERSION"
616     fi
617
618     # doesn't make any sense to build OFED for xen domX's
619     if $XEN; then
620         OFED_VERSION=""
621     fi
622
623     # XXX - set_rpm_smp_type is an ugly undeterministic hack.  it needs to
624     #       go away and the target just specify the $RPMSMPTYPE
625     [ -z "$RPMSMPTYPE" ] && set_rpm_smp_type
626
627     # CC might have been overwritten in TARGET_FILE
628     if [[ $CC != ccache\ * ]] && which "$CCACHE" &>/dev/null; then
629         export CCACHE && export CC="ccache $CC"
630     fi
631
632     if [ ! "$KERNELTREE" = "" ] && [ -d "$KERNELTREE" ]; then
633         KERNELDIR="$KERNELTREE/${lnxmaj}"
634         [ -d "$KERNELDIR" ] || mkdir "$KERNELDIR"
635     fi
636
637     # verify the series is available
638     if [ "$SERIES" ]; then
639         for series in $SERIES; do
640             for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
641                 [ -r "$patchesdir/series/$series" ] && continue 2
642             done
643             fatal 1 "Target $TARGET's series $SERIES could not be found.\nSearched:\n\t$EXTERNAL_PATCHES/series\n\t$TOPDIR/lustre/lustre/kernel_patches/series."
644         done
645     fi
646
647     # set the location of the .config file
648     local XENPOSTFIX=""
649     if $XEN; then
650         XENPOSTFIX="-xen"
651     fi
652
653     if [ -f $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET-$TARGET_ARCH.config ]; then
654         CONFIG_FILE="$TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET$XENPOSTFIX-$TARGET_ARCH.config"
655     fi
656
657     local lnxrelnew=${lnxrel//-/_}
658
659     # remember the EXTRA_VERSION before we diddle it here
660     # XXX - we really should not diddle with any values read in from the
661     #       target file.  if we want to modify a value, we should create
662     #       a new variable.
663     PRISTINE_EXTRA_VERSION=$EXTRA_VERSION
664
665     if ! $PATCHLESS && [ ! -f "$CONFIG_FILE" ]; then
666         fatal 1 "Config file for target $TARGET missing from $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/."
667     fi
668
669     if [ "$EXTRA_VERSION_save" ]; then
670         EXTRA_VERSION="$EXTRA_VERSION_save"
671     elif ! $RELEASE; then
672         # if there is no patch series, then this is not a lustre specific
673         # kernel.  don't make it look like one
674         if $PATCHLESS || [ -n "$SERIES" ]; then
675             EXTRA_VERSION=$(echo $EXTRA_VERSION | sed -e "s/\(.*_lustre\)\..*/\1/")
676         fi
677     fi
678     # EXTRA_VERSION=${EXTRA_VERSION//-/_}
679
680     ALL_ARCHS="$BASE_ARCHS $BIGMEM_ARCHS $BOOT_ARCHS $JENSEN_ARCHS $SMP_ARCHS $BIGSMP_ARCHS $PSERIES64_ARCHS $UP_ARCHS"
681
682     BUILD_ARCHS=
683     for arch in $(uniqify "$ALL_ARCHS"); do
684         if [ -z "$TARGET_ARCHS" ] ||
685            [[ \ $TARGET_ARCHS\  = *\ $arch\ * ]]; then
686             BUILD_ARCHS="$BUILD_ARCHS $arch"
687         fi
688     done
689     [ "$BUILD_ARCHS" ] || usage 1 "No available target archs to build."
690     echo "Building for: $BUILD_ARCHS"
691 }
692
693 tarflags() {
694     local file="$1"
695
696     echo -n '--wildcards '
697     case "$file" in
698         '')
699             fatal 1 "tarflags(): File name argument missing."
700             ;;
701         *.tar.gz | *.tgz)
702             echo '-zxf'
703             ;;
704         *.tar.bz2)
705             echo '-jxf'
706             ;;
707         *.tar)
708             echo '-xf'
709             ;;
710         *)
711             fatal 1 "tarflags(): Unrecognized tar extension in file: $1"
712             ;;
713     esac
714
715 }
716
717 untar() {
718     local tarfile="$1"
719     shift
720     local extractfile="$@"
721
722     echo "Untarring ${tarfile##*/}..."
723     tar $(tarflags "$tarfile") "$tarfile" $extractfile
724
725 }
726
727 unpack_ofed() {
728
729     if ! untar "$KERNELTREE/OFED-${OFED_VERSION}.tgz"; then
730         return 1
731     fi
732     [ -d OFED ] || ln -sf OFED-[0-9].[0-9]* OFED
733
734 }
735
736 unpack_lustre() {
737
738     untar "$LUSTRE" || fatal 1 "Error unpacking Lustre tarball"
739     [ -d lustre ] || ln -sf lustre-[0-9].[0-9]* lustre
740
741 }
742
743 do_patch_linux() {
744
745     local do_patch=${1:-true}
746
747     FULL_PATCH="$PWD/lustre-kernel-${TARGET}-${EXTRA_VERSION}.patch"
748     [ -f "$FULL_PATCH" ] && rm -f "$FULL_PATCH"
749     $do_patch && pushd linux >/dev/null
750     for series in $SERIES; do
751         echo -n "Applying series $series:"
752         for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
753             [ -r "$patchesdir/series/$series" ] || continue
754             SERIES_FILE="$patchesdir/series/$series"
755             for patch in $(<"$SERIES_FILE"); do
756                 echo -n " $patch"
757                 PATCH_FILE="$patchesdir/patches/$patch"
758                 [ -r "$PATCH_FILE" ] || \
759                     fatal 1 "Patch $patch does not exist in Lustre tree."
760                 cat "$PATCH_FILE" >> "$FULL_PATCH" || {
761                     rm -f $FULL_PATCH
762                     fatal 1 "Error adding patch $patch to full patch."
763                 }
764                 if $do_patch; then
765                     patch -s -p1 < "$PATCH_FILE" 2>&1 || {
766                         rm -f $FULL_PATCH
767                         fatal 1 "Error applying patch $patch."
768                     }
769                 fi
770             done
771             break
772         done
773         echo
774     done
775     $do_patch && popd >/dev/null
776     echo "Full patch has been saved in ${FULL_PATCH##*/}."
777
778 }
779
780 build_lustre() {
781     local linux="$1"
782     local linuxobj="$2"
783     local configure_args=""
784
785     cp "$LUSTRE" SOURCES
786
787     pushd lustre >/dev/null
788
789     if ! build_lustre_dkms; then
790         popd >/dev/null # pushd lustre
791         return 255
792     fi
793
794     echo "Building Lustre RPMs for: $BUILD_ARCHS..."
795
796     # If server we now build the spl and zfs modules against the lustre kernel.
797     # These are required prior to the building of lustre server. Client does
798     # not require spl/zfs. Use !PATCHLESS to indicate server which follows the
799     # line above so is at least consistant.
800     if [ $PATCHLESS == false ] && [ "x$WITH_ZFS" == "x" ]; then
801         if ! build_spl_zfs; then
802             popd >/dev/null # pushd lustre
803             return 255
804         fi
805     fi
806
807     if $PATCHLESS; then
808         configure_args="$configure_args --disable-server"
809     fi
810
811     # ditto for the lustre-tests boolean
812     if ! $LUSTRE_TESTS; then
813         configure_args="$configure_args --disable-tests"
814     fi
815
816     if ! $IOKITRPM; then
817         configure_args="$configure_args --disable-iokit"
818     fi
819
820     if ! $OSDZFSRPM; then
821         configure_args="$configure_args --without-zfs"
822     fi
823
824     if ! $OSDLDISKFSRPM; then
825         configure_args="$configure_args --disable-ldiskfs"
826     fi
827
828     configure_args="$configure_args --with-linux=$linux"
829     configure_args="$configure_args ${linuxobj:+--with-linux-obj=$linuxobj}"
830
831     # allow environment setting to override ldiskfs series selection
832     [ -n "$LDISKFS_SERIES" ] && export LDISKFS_SERIES
833
834     ./configure $configure_args $CONFIGURE_FLAGS 2>&1 ||
835         fatal 1 "Error in configure."
836     make rpms 2>&1 ||
837         fatal 1 "Error building rpms for $BUILD_ARCHS."
838
839     # move RPMs into place where they are expected to be
840     for arch in $BUILD_ARCHS; do
841         mv -f *lustre*.${arch}.rpm $TOPDIR/RPMS/${arch}/
842     done
843     mv -f lustre-*.src.rpm $TOPDIR/SRPMS/
844
845     popd >/dev/null
846
847     return 0
848 }
849
850 # Only zfs Lustre DKMS Server is supported
851 build_lustre_dkms() {
852     local build_args=""
853     local name_prefix="lustre"
854     local ver=$(sed -n -e 's/^LUSTRE_VERSION = //p' LUSTRE-VERSION-FILE)
855
856     echo "Building Lustre DKMS RPMs for: $BUILD_ARCHS..."
857     ./configure --enable-dist || fatal 1 "Error in DKMS configure."
858
859     if $PATCHLESS; then
860         build_args="--without servers"
861         name_prefix="lustre-client"
862     fi
863
864     rpmbuild --define "_topdir $TOPDIR" $build_args -bs lustre-dkms.spec ||
865         fatal 1 "Error building DKMS .src.rpm for $BUILD_ARCHS."
866     rpmbuild --define "_topdir $TOPDIR" $build_args \
867              --rebuild $TOPDIR/SRPMS/$name_prefix-dkms-$ver-*.src.rpm ||
868         fatal 1 "Error building DKMS .rpm for $BUILD_ARCHS."
869
870     return 0
871 }
872
873 ###
874 # build_spl_zfs
875 #
876 # Fetch spl/zfs from the git repo and prepare for lustre build
877 #
878 # Overrides:
879 #   SPLZFSGITREPO - URI of directory where spl.git and zfs.git are located
880 #   SPLZFSTAG     - Tag to checkout of clone repositories
881 #   SPLZFSVER     - Version to checkout of both (format zfs/spl-$SPLZFSVER)
882 #
883 # return 0 if successful, else 255
884 build_spl_zfs() {
885     # make sure the RPM build environment is set up
886     pushd $TOPDIR
887     create_rpmbuild_dirs
888     popd
889
890     # The spl/zfs spec files expect RPM_BUILD_ROOT to point to the root of the
891     # destination for the rpms
892     export RPM_BUILD_ROOT=$TOPDIR
893     SPLZFSVER=${SPLZFSVER:-0.6.5.7}
894     SPLZFSTAG=${SPLZFSTAG:-}
895
896     # The files expect a kver to be set to the kernel version .
897     local kver=$(find_linux_release)
898
899     # build and install the spl and zfs (and -devel) RPMs for lustre to use
900     local pkg
901     for pkg in spl zfs; do
902
903         local rpmpkg
904
905         [ "$pkg" == "zfs" ] && spldir="$(ls -d $TOPDIR/usr/src/spl-*|tail -1)"
906
907         # need to fetch the repo in order to build it.
908         # default to github but allow override
909         git clone ${SPLZFSGITREPO:-"https://github.com/zfsonlinux"}/$pkg.git $pkg 2>&1
910
911         pushd $pkg || return 255
912         if [ -n "$SPLZFSTAG" ]; then
913             git checkout $SPLZFSTAG
914         else
915             git checkout -b lbuild $pkg-$SPLZFSVER
916         fi
917
918         # This differentiates between older zfs versions
919         if [ -f $pkg-modules.spec.in ]; then
920             rpmpkg=$pkg-modules
921             specdir=.
922             speclist="$pkg.spec $rpmpkg.spec"
923         else
924             rpmpkg=kmod-$pkg-devel
925             specdir=rpm/generic
926             speclist="$pkg.spec $pkg-kmod.spec $pkg-dkms.spec"
927         fi
928
929         sh autogen.sh || return 255
930
931         if  ! ./configure --with-linux=${LINUX} --with-linux-obj=${LINUXOBJ:-$LINUX} \
932                           ${spldir:+--with-spl="${spldir}"} 2>&1 ||
933             ! make dist 2>&1; then
934             popd
935             return 255
936         fi
937         popd
938
939         ln -f $pkg/$pkg-*.tar.gz $TOPDIR/SOURCES ||
940            error "failed to link $pkg/$pkg-*.tar.gz into $TOPDIR/SOURCES"
941         if [ -f $pkg/scripts/kmodtool ]; then
942             ln -f $pkg/scripts/kmodtool $TOPDIR/SOURCES/
943         fi
944
945         local rpmb
946         if $DO_SRC; then
947             rpmb=-ba
948         else
949             rpmb=-bb
950         fi
951
952         # set search dir for our own kmodtool to find correct
953         # directories
954         export KERNELSOURCE=$(dirname ${LINUX})
955         # Manually build rpms
956         for spec in $speclist; do
957             echo "Building RPMs from $pkg/$specdir/$spec"
958             if ! rpmbuild $rpmb $pkg/$specdir/$spec \
959                 --nodeps -v \
960                 --define "_use_internal_dependency_generator 0" \
961                 --define "require_kdir ${LINUX}" \
962                 ${LINUXOBJ:+--define "require_kobj ${LINUXOBJ}"} \
963                 ${spldir:+--define "require_spldir ${spldir}"} \
964                 --define "kver $kver" \
965                 --define "kernels $kver" \
966                 --define "_tmppath /var/tmp" \
967                 --define "kernelbuildroot $TOPDIR/reused" \
968                 --define "_topdir $TOPDIR" 2>&1; then
969                 return 255
970             fi
971         done
972
973         # We have built the rpms for the package. Now we need to extract the
974         # contained files so we can build further things against them
975         local rpms=$(ls -1 $TOPDIR/RPMS/*/$rpmpkg-*.rpm)
976
977         # cpio only extract to pwd so we need to go there.
978         pushd $TOPDIR
979         local rpm
980         for rpm in $rpms; do
981             rpm2cpio $rpm | cpio -id
982         done
983
984         if [ "$pkg" == "zfs" ]; then
985             # We also need to extract both the zfs and zfs-devel rpms
986             # the zfs rpm is needed because it has the actual libraries in
987             # it and the zfs-devel rpm only has unversioned symlinks to the
988             # libraries in the zfs rpm
989             # this will all change one day when we have a libzfs rpm per
990             # https://github.com/zfsonlinux/zfs/issues/2329
991             # and it looks like it could be one day soon:
992             # https://github.com/zfsonlinux/zfs/pull/2341
993             local devel_rpms=$(ls -1 $TOPDIR/RPMS/*/{$pkg-devel,$pkg-$SPLZFSVER,lib*}-*.rpm)
994             for rpm in $devel_rpms; do
995                 rpm2cpio $rpm | cpio -id
996             done
997             CONFIGURE_FLAGS="--with-$pkg-devel=$TOPDIR ${CONFIGURE_FLAGS}"
998         fi
999         popd
1000
1001         CONFIGURE_FLAGS="--with-$pkg=$(ls -d $TOPDIR/usr/src/$pkg-*|tail -1) ${CONFIGURE_FLAGS}"
1002         CONFIGURE_FLAGS="--with-$pkg-obj=$(ls -d $TOPDIR/usr/src/$pkg-*/$kver*|tail -1) ${CONFIGURE_FLAGS}"
1003     done
1004
1005     OSDZFSRPM=true
1006
1007     return 0
1008 }
1009
1010 stage() {
1011
1012     [ "$STAGEDIR" ] || return 0
1013
1014     for arch in $BUILD_ARCHS; do
1015         rpmdir="${STAGEDIR}/${CANONICAL_TARGET}-${arch}"
1016         echo "${0##*/}: Copying RPMs into ${rpmdir}"
1017         mkdir -p "${rpmdir}"
1018         for rpm in $(ls RPMS/${arch}/*.rpm RPMS/noarch/*.rpm); do
1019             cp -v $rpm "${rpmdir}"
1020         done
1021     done
1022
1023     cp -v "$LUSTRE" "$STAGEDIR"
1024
1025 }
1026
1027 set_rpm_smp_type() {
1028
1029     local infact_arch="${TARGET_ARCH}"
1030
1031     RPMSMPTYPE=""
1032     [ "$infact_arch" == "i586" ] && infact_arch="i686"
1033
1034     local smp_type
1035     for smp_type in $SMP_ARCHS; do
1036         [ $infact_arch == $smp_type ] && RPMSMPTYPE=smp && break
1037     done
1038
1039     for smp_type in $BIGSMP_ARCHS; do
1040         [ $infact_arch == $smp_type ] && RPMSMPTYPE=bigsmp && break
1041     done
1042
1043     for smp_type in $PPC64_ARCHS; do
1044         [ $infact_arch == $smp_type ] && RPMSMPTYPE=ppc64 && break
1045     done
1046
1047     for smp_type in $DEFAULT_ARCHS; do
1048         [ $infact_arch == $smp_type ] && RPMSMPTYPE=default && break
1049     done
1050
1051 }
1052
1053 # This function takes a linux include tree and digs out the linux release
1054 # from it. It is never called directly, only called from the distro
1055 # specific function find_linux_release() in lbuild-{rhel,sles}.
1056 _find_linux_release() {
1057     local SRC="$1"
1058     local LINUXRELEASEHEADER=""
1059
1060     LINUXRELEASEHEADER=$SRC/include/linux/version.h
1061     if [ -s $SRC/include/generated/utsrelease.h ]; then
1062         LINUXRELEASEHEADER=$SRC/include/generated/utsrelease.h
1063     elif [ -s $SRC/include/linux/utsrelease.h ]; then
1064         LINUXRELEASEHEADER=$SRC/include/linux/utsrelease.h
1065     fi
1066
1067     if [ ! -s $LINUXRELEASEHEADER ]; then
1068         fatal 1 "could not find UTS_RELEASE"
1069     fi
1070
1071     sed -ne 's/#define UTS_RELEASE "\(.*\)"$/\1/p' $LINUXRELEASEHEADER
1072 }
1073
1074 # unpack kernel(/source/devel) RPM
1075 #
1076 # This function and it's setting of $LINUX and $LINUXOBJ is a total hack that
1077 # needs to completely refactored.  It completely ingores that $BUILD_ARCHS may
1078 # contain a list of arches for which rpmbuild commands (including the one for
1079 # lustre itself)
1080 unpack_linux_devel_rpm() {
1081     local kernelrpm="${1}"
1082
1083     [ -f "$kernelrpm" ] || return 255
1084     [ -d $TOPDIR/reused ] || mkdir $TOPDIR/reused || return 255
1085
1086     pushd $TOPDIR/reused &>/dev/null || return 255
1087
1088     if ! rpm2cpio < "$kernelrpm" | cpio -id > /dev/null 2>&1; then
1089         return 255
1090     fi
1091
1092     # call a distro specific hook, if available
1093     if type -p unpack_linux_devel_rpm-$DISTROMAJ; then
1094         if ! unpack_linux_devel_rpm-$DISTROMAJ "$kernelrpm"; then
1095             return 255
1096         fi
1097     fi
1098
1099     popd &>/dev/null
1100
1101     find_linux_devel_paths $TOPDIR/reused
1102
1103     return 0
1104
1105 }
1106
1107 build_kernel_ib() {
1108     local linux="$1"
1109     local kib_prefix="$2"
1110     local kib_rpm="$3"
1111
1112     # build kernel-ib{,-devel}/compat-rdma{,-devel}
1113     local K_SRC="K_SRC"
1114     # ofed 1.3 had a bug in the rpm spec
1115     if [ "$OFED_VERSION" = "1.3" ]; then
1116         K_SRC="KSRC"
1117     fi
1118
1119     local OFED_CORE="--with-core-mod --with-ipoib-mod --with-user_mad-mod --with-user_access-mod --with-addr_trans-mod"
1120     local OFED_HARDWARE="--with-mthca-mod --with-mlx4-mod --with-mlx4_en-mod --with-cxgb3-mod --with-nes-mod --with-qib-mod"
1121
1122     if compare_version $OFED_VERSION 3.0; then
1123         OFED_CORE="$OFED_CORE --with-madeye-mod --with-rds-mod"
1124     else
1125         OFED_HARDWARE="$OFED_HARDWARE --with-mlx5-mod --with-cxgb4-mod --with-ocrdma-mod --with-qib-mod"
1126     fi
1127
1128     # some I/B drivers are architecture dependent and kernel-ib's configure
1129     # does not figure it out for us ~sigh~
1130     case "$TARGET_ARCH" in
1131         ppc64)
1132             OFED_HARDWARE="$OFED_HARDWARE --with-ehca-mod"
1133             ;;
1134     esac
1135     # we're no longer shipping the OFED iSCSI target
1136     #OFED_ISCSI="--with-srp-mod --with-srp-target-mod"
1137     OFED_ISCSI="--with-srp-mod"
1138     ## ISER module has no backport support as of OFED 1.5 (i.e. only builds on
1139     ##kernels >= 2.6.30)
1140     #if [[ $OFED_VERSION = 1.[0-4]* ]]; then
1141     #   OFED_ISCSI="$OFED_ISCSI --with-iser-mod"
1142     #fi
1143
1144     # assume we are just rebuilding the SRPM
1145     local BUILD_TYPE=${BUILD_TYPE:-"--rebuild"}
1146     local SOURCE="${TOPDIR}/OFED/SRPMS/${kib_prefix}-*.src.rpm"
1147
1148     # but switch to building from the SPEC if we need to apply patches
1149     if ls ${TOPDIR}/lustre/contrib/patches/ofed/* >/dev/null; then
1150         BUILD_TYPE="-bb"
1151         rpm --define "_topdir ${TOPDIR}" -ivh $SOURCE
1152         SOURCE="${TOPDIR}/SPECS/${kib_prefix}.spec"
1153         local file ed_fragment1 ed_fragment2 n=1
1154         for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.patch); do
1155             ed_fragment1="$ed_fragment1
1156 Patch$n: ${file%%*/}"
1157             ed_fragment2="$ed_fragment2
1158 %patch$n -p0"
1159             cp $file ${TOPDIR}/SOURCES
1160             let n=$n+1
1161         done
1162         for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.ed); do
1163             # Only apply the ed-scripts that should be used for the canonical target
1164             # ed-files in ${TOPDIR}/lustre/contrib/patches/ofed/ have to follow the naming
1165             # convention
1166             # <two-digits>-<descriptive-name>:<canonical_target_1>: ...:<canonical_target_N>.ed
1167             # To apply the same change to multiple canonical target simply specify
1168             # a list of colon separated canoncial target names in the file name.
1169             echo "$file" | grep -q -e ":${CANONICAL_TARGET}:" \
1170                                    -e ":${CANONICAL_TARGET}.ed$"
1171             if [ $? -eq 0 ] ; then
1172                 ed_fragment3="$ed_fragment3
1173 $(cat $file)"
1174                 let n=$n+1
1175             fi
1176         done
1177
1178         if [ $n -gt 1 ]; then
1179             ed $SOURCE <<EOF
1180 /^Source: /a
1181 $ed_fragment1
1182 .
1183 /^%setup /a
1184 $ed_fragment2
1185 .
1186 $ed_fragment3
1187 wq
1188 EOF
1189         fi
1190     fi
1191
1192     local linuxrelease=$(find_linux_release)
1193     if compare_version $OFED_VERSION 3.0; then
1194         local OFA_KERNEL_RELEASE=$(echo -n ${linuxrelease} | sed -e 's/-/_/g')
1195     fi
1196     if ! rpmbuild $BUILD_TYPE --define 'build_kernel_ib 1' --define 'build_kernel_ib_devel 1' \
1197                   --define "_topdir ${TOPDIR}" --target ${TARGET_ARCH} \
1198                   --define "KVERSION ${linuxrelease}" \
1199                   --define "$K_SRC ${linux}" \
1200                   --define "LIB_MOD_DIR /lib/modules/${linuxrelease}/updates" \
1201                   ${OFA_KERNEL_RELEASE:+--define "_release $OFA_KERNEL_RELEASE"} \
1202                   --define "configure_options --without-quilt $OFED_CORE $OFED_HARDWARE $OFED_ISCSI" \
1203                   ${SOURCE} 2>&1; then
1204         fatal 1 "Error building ${kib_rpm}"
1205     fi
1206
1207 }
1208
1209 store_for_reuse() {
1210     local articles="$1"
1211     local module="$2"
1212     local location="$3"
1213     local signature="$4"
1214     local use_links="$5"
1215
1216     local linkflag=""
1217     if $use_links; then
1218         linkflag="l"
1219     fi
1220
1221     local default_iface=$(/sbin/ip route get 192.1.1.1 | sed -ne 's/.* dev \(.*\)  * src .*/\1/p')
1222     if [ -z "$default_iface" ]; then
1223         fatal 1 "Failed to determine the default route interface"
1224     fi
1225     local unique_id=$(/sbin/ip addr show dev $default_iface | sed -ne '/ inet /s/ *inet \(.*\)\/.*/\1/p' | head -1)
1226     if [ -z "$unique_id" ]; then
1227         fatal 1 "Failed to determine a unique id from interface $default_interface"
1228     fi
1229
1230     local finallocation="$location"/"$signature"/"$module"
1231     location="$location"/"$signature-${unique_id}"/"$module"
1232     mkdir -p "$location"
1233     # the cleanup script removes any directory that doesn't have a
1234     # .lastused, so let's try to prevent that as soon as we can
1235     # this solution still slightly racy with the cleanup script
1236     # but the race is a lot tighter now
1237     touch -t 197001010000 "$location/.lastused"
1238     ## use eval/echo here to make sure shell expansions are performed
1239     #if ! cp -a${linkflag} $(eval echo $articles) "$location"; then
1240     local article
1241     for article in $(eval echo $articles); do
1242         if ! cp -a${linkflag} "$article" "$location"; then
1243             error "Failed to copy \"$article\" to \"$location\" in store_for_reuse()"
1244             # rename the cache location so that it's not cached
1245             # product, but is around for analysis
1246             mv "$location"{,-bad-$(date +%s)} ||
1247                 error "failed to clean up a failed cache attempt" \
1248                       "in \"$location\" -- manual cleanup will be" \
1249                       "necessary"
1250             return 1
1251         fi
1252     done
1253
1254     # flag the cache as complete (i.e. in case lbuild was previously
1255     # interrupted while caching)
1256     touch "$location/.lastused"
1257
1258     # put the temporary location into the final location
1259     # (last one wins)
1260     mkdir -p "${finallocation%/*}"
1261     mv "$location" "$finallocation"
1262     rmdir "${location%/*}"
1263     return 0
1264
1265 }
1266
1267 reuse() {
1268     local module="$1"
1269     local dest="$2"
1270     local use_links="${3:-false}"
1271     local signature="$4"
1272
1273     if [ -n "$REUSEBUILD" ] && [ -d "$REUSEBUILD/$signature/$module" ]; then
1274         if [ ! -f "$REUSEBUILD/$signature/$module/.lastused" ]; then
1275             # the .lastused flag is populated at the end of the caching to
1276             # signal that the caching was completed.  if that flag is not
1277             # there, then the cache is invalid (and should be removed in fact)
1278             mv "$REUSEBUILD/$signature/$module"{,-bad-$(date +%s)} ||
1279                 fatal 1 "failed to clean up a bad cache in location $REUSEBUILD/$signature/$module\" -- manual cleanup will be necessary"
1280             return 1
1281         fi
1282
1283         # so that we know how stale this entry is
1284         touch $REUSEBUILD/$signature/$module/.lastused
1285
1286         if $use_links; then
1287             if ls $REUSEBUILD/$signature/$module/* >/dev/null 2>&1; then
1288                 cp -al $REUSEBUILD/$signature/$module/* $dest/
1289             fi
1290         else
1291             # copying is pretty heavy
1292             # cp -a $REUSEBUILD/$signature/$module/* $dest/
1293             # do some creative symlinking instead
1294             local dir
1295             for dir in BUILD SRPMS SPECS; do
1296                 if ls $REUSEBUILD/$signature/$module/$dir/* >/dev/null 2>&1; then
1297                     ln -s $REUSEBUILD/$signature/$module/$dir/* $dest/$dir
1298                 fi
1299             done
1300             # sources have to be copied by file because we need SOURCES to
1301             # be a dir we can write into
1302 # could overrun ls's arg list here
1303             #ls $REUSEBUILD/$signature/$module/SOURCES/* |
1304             find $REUSEBUILD/$signature/$module/SOURCES/ -type f |
1305                 xargs ln -t $dest/SOURCES -s
1306
1307             # same for RPMS/* dirs
1308 # could overrun ls's arg list here
1309             #ls $REUSEBUILD/$signature/$module/RPMS/$TARGET_ARCH/* |
1310             local dir
1311             for dir in $REUSEBUILD/$signature/$module/RPMS/*; do
1312                 mkdir -p $dest/RPMS/${dir##*/}
1313                 find $dir -type f |
1314                   xargs ln -t $dest/RPMS/${dir##*/} -s
1315             done
1316         fi
1317         return 0
1318     else
1319         return 1
1320     fi
1321 }
1322
1323 basearch() {
1324     local arch="$1"
1325
1326     if [[ $arch = i[3456]86 ]]; then
1327         echo "i386"
1328     else
1329         echo "$arch"
1330     fi
1331
1332 }
1333
1334 build_kernel_with_srpm() {
1335     local outfd=$1
1336
1337     if [ -z "$outfd" ] || [ $outfd = 1 ]; then
1338         fatal 1 "You must supply a file descriptor to ${FUNCNAME[0]} and it cannot be 1"
1339     fi
1340
1341     # need to generate the patch for this target
1342     do_patch_linux false >&${outfd}    # sets global $FULL_PATCH (yeah, yuck)
1343
1344     # get an md5sum of the kernel patch + config for reuse check
1345     # XXX really, there needs to be a signature and a CONFIG_FILE per arch
1346     #     in BUILD_ARCHS
1347     local release_str
1348     if $RELEASE; then
1349         local release_str="RELEASE=$RELEASE\n"
1350     fi
1351
1352     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1353         local REUSE_SIGNATURE=$({ echo -en $release_str;
1354                                   echo $BUILD_GEN;
1355                                   cat "$CONFIG_FILE";
1356                                   cat "$TARGET_FILE" |
1357                                   sed -e '/_VERSION=/s/_[0-9]*_g.*$//g';
1358                                   cat "$FULL_PATCH";
1359                                   cat "$LBUILD_DIR/lbuild";
1360                                   cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1361                                 md5sum | cut -d" " -f1)
1362         # see if we can link to the reuse pool
1363         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1364         #       "library"
1365         local CAN_LINK_FOR_REUSE=false
1366         touch $REUSEBUILD/$$
1367         if cp -al $REUSEBUILD/$$ $TOPDIR/ 2>/dev/null; then
1368             CAN_LINK_FOR_REUSE=true
1369         fi
1370         rm $REUSEBUILD/$$
1371     fi
1372
1373     # the extra version string to use for the kernel (which might be a reused
1374     # kernel, remember)
1375     local kernel_extra_version=""
1376     if ! $USE_BUILD_CACHE || ! reuse kernel "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1377                                    "$REUSE_SIGNATURE"; then
1378         # nothing cached, build from scratch
1379         if [ ! -r "$KERNELDIR/$KERNEL_SRPM" ]; then
1380             echo "Downloading kernel SRPM" >&${outfd}
1381             download_srpm "$CANONICAL_TARGET" "$KERNEL_SRPM" >&${outfd}
1382         fi
1383
1384         if ! rpm -ivh $KERNELDIR/$KERNEL_SRPM \
1385                   --define "_topdir $TOPDIR" >&${outfd} 2>&1; then
1386             # should we clean this up or leave it for analysis?
1387             #rm -rf $RPMTOPDIR
1388             fatal 1 "Error installing kernel SRPM."
1389         fi
1390
1391         # put the Lustre kernel patch into the RPM build tree
1392         cp $FULL_PATCH $TOPDIR/SOURCES/linux-${lnxmaj}-lustre.patch
1393         prepare_and_build_srpm >&${outfd} ||
1394             fatal 1 "failed to prepare_and_build_srpm"
1395
1396         if [ -z "$REUSE_SIGNATURE" ]; then
1397             echo "No reuse signature was caculated so not storing the built kernel" >&${outfd}
1398         else
1399             # store the resulting kernel RPM build tree for future use
1400             echo "Storing the built kernel for future reuse" >&${outfd}
1401             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,SRPMS,RPMS}" \
1402                                  "kernel" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1403                                  "$CAN_LINK_FOR_REUSE"; then
1404                 error "Failed to store kernel RPMS for reuse"
1405                 echo "unknown" >&${outfd}
1406                 return 1
1407             fi
1408         fi
1409     fi  # build reuse
1410
1411     # figure out the EXTRA_VERSION of the kernel we built or are re-using
1412     local KERNEL_RPM
1413     if ! KERNEL_RPM=$(find_rpm "$TOPDIR/RPMS/$TARGET_ARCH/" provides "^kernel(-default)? ="); then
1414         fatal 1 "Failed to find a kernel RPM in $TOPDIR/RPMS/$TARGET_ARCH/"
1415     fi
1416     kernel_extra_version=$(rpm -q --queryformat "%{RELEASE}" -p $TOPDIR/RPMS/$TARGET_ARCH/$KERNEL_RPM)
1417
1418     # should now have the following RPMs
1419     # $TOPDIR/RPMS/$arch/kernel-lustre-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1420     # $TOPDIR/RPMS/$arch/kernel-lustre-devel-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1421     # $TOPDIR/RPMS/$arch/kernel-lustre-headers-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1422     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-common-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1423     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1424
1425     echo $kernel_extra_version
1426     return 0
1427
1428 }
1429
1430 # build OFED
1431 # globals used:
1432 #    TOPDIR
1433 #    REUSEBUILD, USE_BUILD_CACHE
1434 #    CONFIGURE_FLAGS
1435
1436 build_ofed() {
1437     local linux="$1"
1438     local ofed_version="$2"
1439     local kib_prefix
1440     local kib_rpm
1441
1442     # if an ofed version is given, then it means use OFED proper,
1443     # not any vendor specific "inkernel" version
1444     if [ -z "$ofed_version" ]; then
1445         return 0
1446     fi
1447
1448     if [ "$ofed_version" = "inkernel" ]; then
1449         # see if there is a distro specific override for this and use
1450         # that if it exists
1451         # XXX we need to better integrate a distro specific override with
1452         #     the rest of this function so that all of the reuse cache
1453         #     stuff is leveraged given that 80% of this function is reuse
1454         if type -p build_ofed-$DISTROMAJ; then
1455             local ofed_location
1456             ofed_location=$(build_ofed-$DISTROMAJ ${STDOUT})
1457             local rc=${PIPESTATUS[0]}
1458             CONFIGURE_FLAGS="--with-o2ib=${ofed_location} ${CONFIGURE_FLAGS}"
1459             return $rc
1460         else
1461             return 0
1462         fi
1463     elif compare_version $OFED_VERSION 3.0; then
1464         kib_prefix="ofa_kernel"
1465         kib_rpm="kernel-ib"
1466     else
1467         kib_prefix="compat-rdma"
1468         kib_rpm="compat-rdma"
1469     fi
1470
1471     # build kernel-ib/compat-rdma
1472     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1473         local REUSE_SIGNATURE=$({ echo "$ofed_version";
1474                                   echo "$(find_linux_release;
1475                                   echo "$BUILD_GEN")";
1476                                   cat "${linux}/include/linux/autoconf.h";
1477                                   cat "$LBUILD_DIR/lbuild";
1478                                   cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1479                                 md5sum | cut -d" " -f1)
1480         # see if we can link to the reuse pool
1481         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1482         #       "library"
1483         local CAN_LINK_FOR_REUSE=false
1484         touch $REUSEBUILD/$$
1485         if cp -al $REUSEBUILD/$$ $TOPDIR/; then
1486             CAN_LINK_FOR_REUSE=true
1487         fi
1488         rm $REUSEBUILD/$$
1489     fi
1490
1491     if ! $USE_BUILD_CACHE || ! reuse ofed "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1492                                    "$REUSE_SIGNATURE"; then
1493         if [ -n "$REUSE_SIGNATURE" ]; then
1494             # stash away the existing built articles for a moment
1495             mkdir bak
1496             mv {BUILD,{S,}RPMS,S{OURCE,PEC}S} bak
1497             function mv_back {
1498                 pushd bak
1499                 find . | cpio -pudlm ..
1500                 popd
1501                 rm -rf bak
1502             }
1503             create_rpmbuild_dirs
1504         fi
1505         # build it
1506         build_kernel_ib "${linux}" "${kib_prefix}" "${kib_rpm}"
1507
1508         if [ -z "$REUSE_SIGNATURE" ]; then
1509             echo "No reuse signature was caculated so not storing the built ofed"
1510         else
1511             # store the resulting RPM build tree for future use
1512             echo "Storing the built ofed for future reuse"
1513             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,BUILD,SRPMS,RPMS}" \
1514                                  "ofed" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1515                                  "$CAN_LINK_FOR_REUSE"; then
1516                 error "Failed to store OFED RPMS for reuse"
1517                 mv_back
1518                 return 1
1519             fi
1520             # put the stuff we stashed away back
1521             mv_back
1522         fi
1523     fi
1524
1525     pushd "$TOPDIR" >/dev/null
1526     rm -rf ${kib_rpm}-devel
1527     mkdir ${kib_rpm}-devel
1528     cd ${kib_rpm}-devel
1529     # the actual ofed RPMs don't have the -rc$n or -$date string appened that
1530     # might be present on the file
1531     #local linuxrelease=$(find_linux_release)
1532     #ofed_version=$(echo $ofed_version |
1533     #               sed -re 's/-(20[0-9]{6,6}-[0-9]{4,4}|rc[0-9]*)$//')
1534     # FIXME
1535     # OFED version will have 'hyphen' for minor release. (e.g. 3.5-1, instead
1536     # of 3.5.1) compat-rdma and compat-rdma-devel could have same version
1537     # number, but currectly not. Once OFED fix this in the future release, we
1538     # can remove following filter.
1539     #ofed_version=$(echo $ofed_version |
1540     #               sed -re 's/-([0-9]*-[rR][cC][0-9]*)$//')
1541     #local rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-${ofed_version}-${linuxrelease//-/_}.*.rpm)
1542     # I dont' know why we have gone through the trouble to filter out the name
1543     # of the rpm there should only be one ${kib_rpm}-devel built
1544     local rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-*.rpm)
1545     if ! rpm2cpio < $rpm | cpio -id; then
1546         fatal 1 "could not unpack the ${kib_rpm}-devel rpm."
1547     fi
1548     CONFIGURE_FLAGS="--with-o2ib=$(pwd)/usr/src/${kib_prefix} ${CONFIGURE_FLAGS}"
1549     popd >/dev/null
1550
1551 }
1552
1553 build_with_srpm() {
1554
1555     if ! $PATCHLESS; then
1556         local kernel_extra_version
1557         if ! kernel_extra_version=$(build_kernel_with_srpm ${STDOUT}); then
1558             fatal 1 "Failed to build the kernel from it's SRPM"
1559         fi
1560
1561         for arch in $BUILD_ARCHS; do
1562             local kernel_devel_rpm
1563             if ! kernel_devel_rpm=$(find_rpm "$TOPDIR/RPMS/$arch/" provides "^$(devel_kernel_name $KERNEL_LUSTRE_NAMING) ="); then
1564                 fatal 1 "Failed to find a kernel development RPM in $TOPDIR/RPMS/$arch/"
1565             fi
1566
1567             # install the -devel RPM in preparation for modules builds
1568             if ! lnxrel="$kernel_extra_version" unpack_linux_devel_rpm \
1569                            "$TOPDIR/RPMS/$arch/$kernel_devel_rpm"; then
1570                 fatal 1 "Could not find the Linux tree in $TOPDIR/RPMS/$arch/$kernel_devel_rpm"
1571             fi
1572         done
1573     else
1574         # need to find and unpack the vendor's own kernel-devel for patchless
1575         # client build
1576         local kernelrpm
1577         if ! kernelrpm=$(find_linux_rpm "-$DEVEL_KERNEL_TYPE"); then
1578             fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ"
1579         fi
1580         if ! lnxrel="$lnxrel" unpack_linux_devel_rpm "$kernelrpm" "-"; then
1581             fatal 1 "Could not find the Linux tree in $kernelrpm"
1582         fi
1583     fi
1584
1585     # ~sigh~  have to make copies of and modify some of the rpm
1586     # infrastructure files so that find-requires can find our unpacked
1587     # kernel-devel artifacts
1588     cp $RPM_HELPERS_DIR/{symset-table,find-requires{,.ksyms}} .
1589     export FIND_REQUIRES="$(pwd)/find-requires"
1590     chmod 755 {symset-table,find-requires{,.ksyms}}
1591     local tmp="$(pwd)"
1592     tmp="${tmp//\//\\/}"
1593     ed find-requires <<EOF
1594 1a
1595 set -x
1596 .
1597 /|.*find-requires.ksyms/s/|/| bash -x/
1598 g/ [^ ]*\/\(find-requires\.ksyms\)/s// $tmp\/\1/g
1599 wq
1600 EOF
1601     ed find-requires.ksyms <<EOF
1602 1a
1603 set -x
1604 .
1605 g/\/.*\/\(symset-table\)/s//$tmp\/\1/g
1606 g/\(\/usr\/src\/kernels\/\)/s//$tmp\/reused\1/g
1607 wq
1608 EOF
1609     ed symset-table <<EOF
1610 1a
1611 set -x
1612 .
1613 g/\(\/boot\/\)/s//$tmp\/reused\1/g
1614 g/\(\/usr\/src\/kernels\/\)/s//$tmp\/reused\1/g
1615 wq
1616 EOF
1617
1618     build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
1619         fatal 1 "error building OFED"
1620
1621     # now build Lustre
1622     if build_lustre "$LINUX" "$LINUXOBJ"; then
1623         # the build worked.  resolve any symlinked files (i.e. from reuse)
1624         # in RPMS/$arch to real files so that that that huge mess of
1625         # complication known as LTS can copy them yet somewhere else.
1626         # is it any wonder this whole process is so damn so?  anyone ever
1627         # heard of hardlinks?  it's this cool new thing that allows you save
1628         # tons of time and space by creating... well you can go read about
1629         # them if you have not heard about them yet.
1630         # can i say how much the implemenation of all of this really impedes
1631         # RPM reuse?
1632         local dir
1633         for dir in RPMS/*; do
1634             pushd $dir
1635             for file in $(ls); do
1636                 if [ -h $file ]; then
1637                     cp $file foo
1638                     mv foo $file
1639                 fi
1640             done
1641             popd
1642         done
1643         # also, for i?86, make sure all of the RPMs are in RPMS/$TARGET_ARCH
1644         # as that's where LTS expects to find them
1645         for dir in RPMS/*; do
1646             if [ $dir = RPMS/$TARGET_ARCH ]; then
1647                 continue
1648             fi
1649             pushd $dir
1650             local files=$(ls)
1651             if [ -n "$files" ]; then
1652                 cp -al $files ../$TARGET_ARCH
1653             fi
1654             popd
1655         done
1656     else
1657         return 1
1658     fi
1659
1660 }
1661
1662 create_rpmbuild_dirs() {
1663
1664     [ -d RPMS ] || mkdir RPMS
1665     for arch in $BUILD_ARCHS; do
1666         if [[ $arch = i?86 ]]; then
1667             # some stupidity in the sles11 kernel spec requires an RPMS/i386
1668             # even if the target arch is i686
1669             [ -d RPMS/i386 ] || mkdir RPMS/i386
1670         fi
1671         [ -d RPMS/$arch ] || mkdir RPMS/$arch
1672     done
1673     [ -d RPMS/noarch ] || mkdir RPMS/noarch
1674     [ -d BUILD ] || mkdir BUILD
1675     [ -d SOURCES ] || mkdir SOURCES
1676     [ -d SPECS ] || mkdir SPECS
1677     [ -d SRPMS ] || mkdir SRPMS
1678
1679 }
1680
1681 new_list() {
1682
1683     echo ""
1684
1685 }
1686
1687 add_list() {
1688     local list="$1"
1689     local item="$2"
1690
1691     echo "$list $item"
1692
1693 }
1694
1695 is_list_member() {
1696     local list="$1"
1697     local item="$2"
1698
1699     [[ $list\  == *\ $item\ * ]]
1700
1701 }
1702
1703 #########################################################################
1704 # Generate a backtrace through the call stack.
1705 #
1706 # Input: None
1707 # Output: None
1708 #########################################################################
1709 backtrace() {
1710     local strip=${1:-1}
1711
1712     local funcname="" sourcefile="" lineno="" n
1713
1714     echo "Call stack: (most recent first)"
1715     for (( n = $strip ; n < ${#FUNCNAME[@]} ; ++n )) ; do
1716         funcname=${FUNCNAME[$n - 1]}
1717         sourcefile=$(basename ${BASH_SOURCE[$n]})
1718         lineno=${BASH_LINENO[$n - 1]}
1719         if [ $n = 1 ]; then
1720             let lineno-=11
1721         fi
1722         # Display function arguments
1723         if [[ ! -z "${BASH_ARGV[@]}" ]]; then
1724             local args newarg j p=0
1725             for (( j = ${BASH_ARGC[$n - 1]}; j > 0; j-- )); do
1726                 newarg=${BASH_ARGV[$j + $p - 1]}
1727                 args="${args:+${args} }'${newarg}'"
1728             done
1729             let p+=${BASH_ARGC[$n - 1]}
1730         fi
1731         echo "  ${funcname} ${args:+${args} }at ${sourcefile}:${lineno}"
1732     done
1733
1734     echo
1735     echo "BEGIN BACKTRACE"
1736
1737     #echo ${BASH_LINENO[*]}
1738     #echo ${BASH_SOURCE[*]}
1739     #echo ${FUNCNAME[*]}
1740     local i=$((${#FUNCNAME[@]} - 1))
1741     while [ $i -ge 0 ]; do
1742         local lineno=${BASH_LINENO[$i]}
1743         if [ $i = 0 ]; then
1744             let lineno-=11
1745         fi
1746         local SOURCELINE="${BASH_SOURCE[$i + 1]}:${lineno}"
1747         # Can't figure out how to get function args from other frames...
1748         local FUNCTION="${FUNCNAME[$i]}()"
1749         echo "$SOURCELINE:$FUNCTION"
1750         i=$((i - 1))
1751     done
1752
1753     echo "END BACKTRACE"
1754
1755     echo $BACKTRACE
1756
1757 }
1758
1759 seen_list=$(new_list)
1760 trap 'set +x;
1761 echo "An unexpected error has occurred at ${BASH_SOURCE[0]##*/}:$((LINENO-1)).
1762 Unfortunately the above line number in the message may or may not be correct,
1763 but details have been send to the lbuild maintainer.  Attempting to continue."; (echo "Untrapped error"
1764 echo
1765 # have we seen this one
1766 echo "checking seen list for ${BASH_SOURCE[0]}:${BASH_LINENO[0]}"
1767
1768 if is_list_member "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}"; then
1769   echo "seen this one already"
1770 else
1771   seen_list=$(add_list "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}")
1772 fi
1773 backtrace
1774 ) ; set $xtrace' ERR
1775 set -E
1776
1777 [ -r ~/.lbuildrc ] && . ~/.lbuildrc
1778
1779 options=$(getopt -o D:h -l kerneltree:,distro:,kernelrpm:,reusebuild:,patchless,ccache,norpm,external-patches:,timestamp:,extraversion:,kerneldir:,linux:,lustre:,nodownload,nosrc,noiokit,ofed-version:,publish,disable-zfs,release,set-value:,src,stage:,target:,target-archs:,with-linux:,xen -- "$@")
1780
1781 if [ $? != 0 ]; then
1782     usage 1
1783 fi
1784
1785 eval set -- "$options"
1786
1787 while [ "$1" ]; do
1788     case "$1" in
1789         '')
1790             usage 1
1791             ;;
1792         --ccache)
1793             CCACHE='ccache'
1794             shift
1795             ;;
1796         -D)
1797             DATE=$2
1798             shift 2
1799             ;;
1800         --external-patches)
1801             EXTERNAL_PATCHES=$2
1802             shift 2
1803             ;;
1804         --extraversion)
1805             EXTRA_VERSION=$2
1806             shift 2
1807             ;;
1808         --help | -h)
1809             usage 0
1810             ;;
1811         --kerneldir)
1812             KERNELDIR=$2
1813             shift 2
1814             ;;
1815         --kerneltree)
1816             if ! KERNELTREE=$(canon_path "$2"); then
1817                 fatal 1 "Could not determine the canonical location of $2"
1818             fi
1819             shift 2
1820             ;;
1821         --linux | --with-linux)
1822             if ! LINUX=$(canon_path "$2"); then
1823                 fatal 1 "Could not determine the canonical location of $2"
1824             fi
1825             shift 2
1826             ;;
1827         --distro)
1828             DISTRO=$2
1829             shift 2
1830             ;;
1831         --reusebuild)
1832             if ! REUSEBUILD=$(canon_path "$2"); then
1833                 fatal 1 "Could not determine the canonical location of $2"
1834             fi
1835             shift 2
1836             ;;
1837         --norpm)
1838             shift
1839             ;;
1840         --noiokit)
1841             IOKITRPM=false
1842             shift
1843             ;;
1844         --patchless)
1845             PATCHLESS=true
1846             shift
1847             ;;
1848         --kernelrpm)
1849             if ! KERNELRPMSBASE=$(canon_path "$2"); then
1850                 fatal 1 "Could not determine the canonical location of $2"
1851             fi
1852             shift 2
1853             ;;
1854         --timestamp)
1855             TIMESTAMP=$2
1856             shift 2
1857             ;;
1858         --lustre)
1859             if ! LUSTRE=$(canon_filepath "$2"); then
1860                 fatal 1 "Could not determine the canonical location of $2"
1861             fi
1862             shift 2
1863             ;;
1864         --nodownload)
1865             DOWNLOAD=false
1866             shift 1
1867             ;;
1868         --nosrc)
1869             DO_SRC=false
1870             shift 1
1871             ;;
1872         --ofed-version)
1873             OFED_VERSION="$2"
1874             shift 2
1875             ;;
1876         --publish)
1877             shift
1878             ;;
1879         --disable-zfs)
1880             WITH_ZFS="no"
1881             shift
1882             ;;
1883         --release)
1884             RELEASE=true
1885             shift
1886             ;;
1887         --src)
1888             DO_SRC=true
1889             shift 1
1890             ;;
1891         --stage)
1892             STAGEDIR=$2
1893             shift 2
1894             ;;
1895         --target)
1896             TARGET=$2
1897             shift 2
1898             ;;
1899         --target-archs)
1900             TARGET_ARCHS=$2
1901             shift 2
1902             ;;
1903         --xen)
1904             XEN=true
1905             shift
1906             ;;
1907         --set-value)
1908             eval $2
1909             shift 2
1910             ;;
1911         --)
1912             shift
1913             # there are actually some lustre configure flags that we need to
1914             # handle ourselves (but we still give them to configure)
1915             if [[ \ $@\  == *\ --disable-tests\ * ]]; then
1916                 LUSTRE_TESTS=false
1917             fi
1918             CONFIGURE_FLAGS=$@
1919             break
1920             ;;
1921         *)
1922             usage 1 "Unrecognized option: $1"
1923             ;;
1924     esac
1925 done
1926
1927 check_options
1928
1929 unpack_lustre
1930
1931 load_target
1932
1933 if [ -n "$OFED_VERSION" -a "$OFED_VERSION" != "inkernel" ]; then
1934     download_ofed
1935     unpack_ofed || fatal 1 "Error unpacking OFED tarball"
1936 fi
1937
1938 # make sure the RPM build environment is set up
1939 create_rpmbuild_dirs
1940
1941 # if an unpacked kernel source tree was given on the command line
1942 # just build lustre with it (nothing distro kernel specific here)
1943 if [ -n "$LINUX" ]; then
1944     find_linux_release() {
1945         _find_linux_release $LINUX
1946     }
1947     build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
1948         fatal 1 "error building OFED"
1949     build_lustre "$LINUX" "$LINUXOBJ"
1950 else
1951     if [ ! -f "${LBUILD_DIR}/lbuild-$DISTROMAJ" ]; then
1952         fatal 1 "${LBUILD_DIR}/lbuild-$DISTROMAJ not found"
1953     fi
1954     source ${LBUILD_DIR}/lbuild-$DISTROMAJ
1955     build_with_srpm || fatal 1 "Failed to build_with_srpm"
1956 fi
1957
1958 stage